Index: uspace/lib/ui/include/types/ui/selectdialog.h
===================================================================
--- uspace/lib/ui/include/types/ui/selectdialog.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/ui/include/types/ui/selectdialog.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,67 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Select dialog
+ */
+
+#ifndef _UI_TYPES_SELECTDIALOG_H
+#define _UI_TYPES_SELECTDIALOG_H
+
+#include <errno.h>
+#include <io/kbd_event.h>
+#include <io/pos_event.h>
+
+struct ui_select_dialog;
+typedef struct ui_select_dialog ui_select_dialog_t;
+
+/** Select dialog parameters */
+typedef struct {
+	/** Window caption */
+	const char *caption;
+	/** Prompt text */
+	const char *prompt;
+} ui_select_dialog_params_t;
+
+/** Select dialog callback */
+typedef struct ui_select_dialog_cb {
+	/** OK button was pressed */
+	void (*bok)(ui_select_dialog_t *, void *, void *);
+	/** Cancel button was pressed */
+	void (*bcancel)(ui_select_dialog_t *, void *);
+	/** Window closure requested (e.g. via close button) */
+	void (*close)(ui_select_dialog_t *, void *);
+} ui_select_dialog_cb_t;
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/ui/include/types/ui/tab.h
===================================================================
--- uspace/lib/ui/include/types/ui/tab.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/ui/include/types/ui/tab.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,45 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Tab
+ */
+
+#ifndef _UI_TYPES_TAB_H
+#define _UI_TYPES_TAB_H
+
+struct ui_menu;
+typedef struct ui_tab ui_tab_t;
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/ui/include/types/ui/tabset.h
===================================================================
--- uspace/lib/ui/include/types/ui/tabset.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/ui/include/types/ui/tabset.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,45 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Menu bar
+ */
+
+#ifndef _UI_TYPES_TABSET_H
+#define _UI_TYPES_TABSET_H
+
+struct ui_tab_set;
+typedef struct ui_tab_set ui_tab_set_t;
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/ui/include/types/ui/testctl.h
===================================================================
--- uspace/lib/ui/include/types/ui/testctl.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/ui/include/types/ui/testctl.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,74 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Label
+ */
+
+#ifndef _UI_TYPES_TESTCTL_H
+#define _UI_TYPES_TESTCTL_H
+
+struct ui_test_ctl;
+typedef struct ui_test_ctl ui_test_ctl_t;
+
+/** Test control response */
+typedef struct {
+	/** Claim to return */
+	ui_evclaim_t claim;
+	/** Result code to return */
+	errno_t rc;
+
+	/** @c true iff destroy was called */
+	bool destroy;
+
+	/** @c true iff paint was called */
+	bool paint;
+
+	/** @c true iff kbd_event was called */
+	bool kbd;
+	/** Keyboard event that was sent */
+	kbd_event_t kevent;
+
+	/** @c true iff pos_event was called */
+	bool pos;
+	/** Position event that was sent */
+	pos_event_t pevent;
+
+	/** @c true iff unfocus was called */
+	bool unfocus;
+	/** Number of remaining foci that was sent */
+	unsigned unfocus_nfocus;
+} ui_tc_resp_t;
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/ui/include/types/ui/ui.h
===================================================================
--- uspace/lib/ui/include/types/ui/ui.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/include/types/ui/ui.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -43,7 +43,9 @@
 
 /** Use the default display service (argument to ui_create()) */
-#define UI_DISPLAY_DEFAULT NULL
+#define UI_DISPLAY_DEFAULT "disp@"
 /** Use the default console service (argument to ui_create()) */
 #define UI_CONSOLE_DEFAULT "cons@"
+/** Use any available service (argument to ui_create()) */
+#define UI_ANY_DEFAULT "@"
 /** Use dummy output (argument to ui_create()) */
 #define UI_DISPLAY_NULL "null@"
@@ -57,4 +59,6 @@
 	/** Console */
 	ui_ws_console,
+	/** Any non-dummy output backend */
+	ui_ws_any,
 	/** Dummy output */
 	ui_ws_null
Index: uspace/lib/ui/include/types/ui/wdecor.h
===================================================================
--- uspace/lib/ui/include/types/ui/wdecor.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/include/types/ui/wdecor.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2020 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -38,4 +38,5 @@
 
 #include <gfx/coord.h>
+#include <types/common.h>
 #include <types/ui/cursor.h>
 
@@ -51,10 +52,17 @@
 	/** Window has a title bar */
 	ui_wds_titlebar = 0x2,
+	/** Window has a system menu handle */
+	ui_wds_sysmenu_hdl = 0x4,
+	/** Window has a minimize button */
+	ui_wds_minimize_btn = 0x8,
+	/** Window has a maximize button */
+	ui_wds_maximize_btn = 0x10,
 	/** Window has a close button */
-	ui_wds_close_btn = 0x4,
+	ui_wds_close_btn = 0x20,
 	/** Window is resizable */
-	ui_wds_resizable = 0x8,
+	ui_wds_resizable = 0x40,
 	/** Window is decorated (default decoration) */
-	ui_wds_decorated = ui_wds_frame | ui_wds_titlebar | ui_wds_close_btn
+	ui_wds_decorated = ui_wds_frame | ui_wds_titlebar | ui_wds_sysmenu_hdl |
+	    ui_wds_minimize_btn | ui_wds_close_btn
 } ui_wdecor_style_t;
 
@@ -76,8 +84,15 @@
 /** Window decoration callbacks */
 typedef struct ui_wdecor_cb {
+	void (*sysmenu_open)(ui_wdecor_t *, void *, sysarg_t);
+	void (*sysmenu_left)(ui_wdecor_t *, void *, sysarg_t);
+	void (*sysmenu_right)(ui_wdecor_t *, void *, sysarg_t);
+	void (*sysmenu_accel)(ui_wdecor_t *, void *, char32_t, sysarg_t);
+	void (*minimize)(ui_wdecor_t *, void *);
+	void (*maximize)(ui_wdecor_t *, void *);
+	void (*unmaximize)(ui_wdecor_t *, void *);
 	void (*close)(ui_wdecor_t *, void *);
-	void (*move)(ui_wdecor_t *, void *, gfx_coord2_t *);
+	void (*move)(ui_wdecor_t *, void *, gfx_coord2_t *, sysarg_t);
 	void (*resize)(ui_wdecor_t *, void *, ui_wdecor_rsztype_t,
-	    gfx_coord2_t *);
+	    gfx_coord2_t *, sysarg_t);
 	void (*set_cursor)(ui_wdecor_t *, void *, ui_stock_cursor_t);
 } ui_wdecor_cb_t;
Index: uspace/lib/ui/include/types/ui/window.h
===================================================================
--- uspace/lib/ui/include/types/ui/window.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/include/types/ui/window.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2020 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -40,4 +40,5 @@
 #include <io/kbd_event.h>
 #include <io/pos_event.h>
+#include <types/common.h>
 #include <types/ui/wdecor.h>
 
@@ -66,5 +67,11 @@
 typedef enum {
 	/** Popup window */
-	ui_wndf_popup = 0x1
+	ui_wndf_popup = 0x1,
+	/** Topmost window */
+	ui_wndf_topmost = 0x2,
+	/** Special system window */
+	ui_wndf_system = 0x4,
+	/** Maximized windows should avoid this window */
+	ui_wndf_avoid = 0x8
 } ui_wnd_flags_t;
 
@@ -83,14 +90,20 @@
 	/** Parent rectangle for popup windows */
 	gfx_rect_t prect;
+	/** Input device associated with the window's seat */
+	sysarg_t idev_id;
 } ui_wnd_params_t;
 
 /** Window callbacks */
 typedef struct ui_window_cb {
+	void (*sysmenu)(ui_window_t *, void *, sysarg_t);
+	void (*minimize)(ui_window_t *, void *);
+	void (*maximize)(ui_window_t *, void *);
+	void (*unmaximize)(ui_window_t *, void *);
 	void (*close)(ui_window_t *, void *);
-	void (*focus)(ui_window_t *, void *);
+	void (*focus)(ui_window_t *, void *, unsigned);
 	void (*kbd)(ui_window_t *, void *, kbd_event_t *);
 	errno_t (*paint)(ui_window_t *, void *);
 	void (*pos)(ui_window_t *, void *, pos_event_t *);
-	void (*unfocus)(ui_window_t *, void *);
+	void (*unfocus)(ui_window_t *, void *, unsigned);
 } ui_window_cb_t;
 
Index: uspace/lib/ui/include/ui/accel.h
===================================================================
--- uspace/lib/ui/include/ui/accel.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/ui/include/ui/accel.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,48 @@
+/*
+ * Copyright (c) 2022 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Accelerator processing
+ */
+
+#ifndef _UI_ACCEL_H
+#define _UI_ACCEL_H
+
+#include <errno.h>
+#include <uchar.h>
+
+extern errno_t ui_accel_process(const char *, char **, char **);
+extern char32_t ui_accel_get(const char *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/ui/include/ui/checkbox.h
===================================================================
--- uspace/lib/ui/include/ui/checkbox.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/include/ui/checkbox.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2020 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * All rights reserved.
  *
@@ -52,4 +52,6 @@
 extern void ui_checkbox_set_cb(ui_checkbox_t *, ui_checkbox_cb_t *, void *);
 extern void ui_checkbox_set_rect(ui_checkbox_t *, gfx_rect_t *);
+extern bool ui_checkbox_get_checked(ui_checkbox_t *);
+extern void ui_checkbox_set_checked(ui_checkbox_t *, bool);
 extern errno_t ui_checkbox_paint(ui_checkbox_t *);
 extern void ui_checkbox_press(ui_checkbox_t *);
Index: uspace/lib/ui/include/ui/clickmatic.h
===================================================================
--- uspace/lib/ui/include/ui/clickmatic.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/ui/include/ui/clickmatic.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,54 @@
+/*
+ * Copyright (c) 2022 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Clickmatic
+ */
+
+#ifndef _UI_CLICKMATIC_H
+#define _UI_CLICKMATIC_H
+
+#include <errno.h>
+#include <gfx/coord.h>
+#include <types/ui/clickmatic.h>
+#include <types/ui/ui.h>
+
+extern errno_t ui_clickmatic_create(ui_t *, ui_clickmatic_t **);
+extern void ui_clickmatic_set_cb(ui_clickmatic_t *, ui_clickmatic_cb_t *,
+    void *);
+extern void ui_clickmatic_destroy(ui_clickmatic_t *);
+extern void ui_clickmatic_press(ui_clickmatic_t *);
+extern void ui_clickmatic_release(ui_clickmatic_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/ui/include/ui/control.h
===================================================================
--- uspace/lib/ui/include/ui/control.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/include/ui/control.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -49,5 +49,5 @@
 extern ui_evclaim_t ui_control_kbd_event(ui_control_t *, kbd_event_t *);
 extern ui_evclaim_t ui_control_pos_event(ui_control_t *, pos_event_t *);
-extern void ui_control_unfocus(ui_control_t *);
+extern void ui_control_unfocus(ui_control_t *, unsigned);
 
 #endif
Index: uspace/lib/ui/include/ui/entry.h
===================================================================
--- uspace/lib/ui/include/ui/entry.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/include/ui/entry.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -54,4 +54,5 @@
 extern const char *ui_entry_get_text(ui_entry_t *);
 extern errno_t ui_entry_paint(ui_entry_t *);
+extern errno_t ui_entry_insert_str(ui_entry_t *, const char *);
 extern void ui_entry_activate(ui_entry_t *);
 extern void ui_entry_deactivate(ui_entry_t *);
Index: uspace/lib/ui/include/ui/filelist.h
===================================================================
--- uspace/lib/ui/include/ui/filelist.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/ui/include/ui/filelist.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,60 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file File list
+ */
+
+#ifndef _UI_FILELIST_H
+#define _UI_FILELIST_H
+
+#include <errno.h>
+#include <gfx/coord.h>
+#include <ui/control.h>
+#include <ui/window.h>
+#include <stdbool.h>
+#include <types/ui/filelist.h>
+
+extern errno_t ui_file_list_create(ui_window_t *, bool, ui_file_list_t **);
+extern void ui_file_list_destroy(ui_file_list_t *);
+extern ui_control_t *ui_file_list_ctl(ui_file_list_t *);
+extern void ui_file_list_set_cb(ui_file_list_t *, ui_file_list_cb_t *, void *);
+extern void ui_file_list_set_rect(ui_file_list_t *, gfx_rect_t *);
+extern errno_t ui_file_list_read_dir(ui_file_list_t *, const char *);
+extern errno_t ui_file_list_activate(ui_file_list_t *);
+extern void ui_file_list_deactivate(ui_file_list_t *);
+extern errno_t ui_file_list_open(ui_file_list_t *, ui_file_list_entry_t *);
+extern ui_file_list_entry_t *ui_file_list_get_cursor(ui_file_list_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/ui/include/ui/fixed.h
===================================================================
--- uspace/lib/ui/include/ui/fixed.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/include/ui/fixed.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -51,5 +51,5 @@
 extern ui_evclaim_t ui_fixed_kbd_event(ui_fixed_t *, kbd_event_t *);
 extern ui_evclaim_t ui_fixed_pos_event(ui_fixed_t *, pos_event_t *);
-extern void ui_fixed_unfocus(ui_fixed_t *);
+extern void ui_fixed_unfocus(ui_fixed_t *, unsigned);
 
 #endif
Index: uspace/lib/ui/include/ui/list.h
===================================================================
--- uspace/lib/ui/include/ui/list.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/ui/include/ui/list.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,77 @@
+/*
+ * Copyright (c) 2024 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file List
+ */
+
+#ifndef _UI_LIST_H
+#define _UI_LIST_H
+
+#include <errno.h>
+#include <gfx/coord.h>
+#include <ui/control.h>
+#include <ui/window.h>
+#include <stdbool.h>
+#include <types/ui/list.h>
+
+extern errno_t ui_list_create(ui_window_t *, bool, ui_list_t **);
+extern void ui_list_destroy(ui_list_t *);
+extern ui_control_t *ui_list_ctl(ui_list_t *);
+extern void ui_list_set_cb(ui_list_t *, ui_list_cb_t *, void *);
+extern void *ui_list_get_cb_arg(ui_list_t *);
+extern void ui_list_set_rect(ui_list_t *, gfx_rect_t *);
+extern errno_t ui_list_activate(ui_list_t *);
+extern void ui_list_deactivate(ui_list_t *);
+extern ui_list_entry_t *ui_list_get_cursor(ui_list_t *);
+extern void ui_list_set_cursor(ui_list_t *, ui_list_entry_t *);
+extern void ui_list_entry_attr_init(ui_list_entry_attr_t *);
+extern errno_t ui_list_entry_append(ui_list_t *,
+    ui_list_entry_attr_t *, ui_list_entry_t **);
+extern void ui_list_entry_move_up(ui_list_entry_t *);
+extern void ui_list_entry_move_down(ui_list_entry_t *);
+extern void ui_list_entry_delete(ui_list_entry_t *);
+extern void *ui_list_entry_get_arg(ui_list_entry_t *);
+extern ui_list_t *ui_list_entry_get_list(ui_list_entry_t *);
+extern errno_t ui_list_entry_set_caption(ui_list_entry_t *, const char *);
+extern size_t ui_list_entries_cnt(ui_list_t *);
+extern errno_t ui_list_sort(ui_list_t *);
+extern void ui_list_cursor_center(ui_list_t *, ui_list_entry_t *);
+extern ui_list_entry_t *ui_list_first(ui_list_t *);
+extern ui_list_entry_t *ui_list_last(ui_list_t *);
+extern ui_list_entry_t *ui_list_next(ui_list_entry_t *);
+extern ui_list_entry_t *ui_list_prev(ui_list_entry_t *);
+extern bool ui_list_is_active(ui_list_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/ui/include/ui/menu.h
===================================================================
--- uspace/lib/ui/include/ui/menu.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/include/ui/menu.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * All rights reserved.
  *
@@ -39,20 +39,25 @@
 #include <errno.h>
 #include <gfx/coord.h>
+#include <io/kbd_event.h>
 #include <io/pos_event.h>
+#include <stdbool.h>
+#include <types/common.h>
+#include <types/ui/event.h>
 #include <types/ui/menu.h>
 #include <types/ui/menubar.h>
-#include <types/ui/event.h>
+#include <types/ui/window.h>
+#include <uchar.h>
 
-extern errno_t ui_menu_create(ui_menu_bar_t *, const char *, ui_menu_t **);
+extern errno_t ui_menu_create(ui_window_t *, ui_menu_t **);
 extern void ui_menu_destroy(ui_menu_t *);
-extern ui_menu_t *ui_menu_first(ui_menu_bar_t *);
-extern ui_menu_t *ui_menu_next(ui_menu_t *);
-extern const char *ui_menu_caption(ui_menu_t *);
-extern void ui_menu_get_rect(ui_menu_t *, gfx_coord2_t *, gfx_rect_t *);
-extern errno_t ui_menu_open(ui_menu_t *, gfx_rect_t *);
+extern void ui_menu_set_cb(ui_menu_t *, ui_menu_cb_t *, void *);
+extern errno_t ui_menu_open(ui_menu_t *, gfx_rect_t *, sysarg_t);
 extern void ui_menu_close(ui_menu_t *);
+extern bool ui_menu_is_open(ui_menu_t *);
 extern errno_t ui_menu_paint(ui_menu_t *, gfx_coord2_t *);
+extern ui_evclaim_t ui_menu_kbd_event(ui_menu_t *, kbd_event_t *);
 extern ui_evclaim_t ui_menu_pos_event(ui_menu_t *, gfx_coord2_t *,
     pos_event_t *);
+extern sysarg_t ui_menu_get_idev_id(ui_menu_t *);
 
 #endif
Index: uspace/lib/ui/include/ui/menubar.h
===================================================================
--- uspace/lib/ui/include/ui/menubar.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/include/ui/menubar.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * All rights reserved.
  *
@@ -40,4 +40,5 @@
 #include <gfx/coord.h>
 #include <io/pos_event.h>
+#include <types/common.h>
 #include <types/ui/menubar.h>
 #include <types/ui/control.h>
@@ -46,13 +47,21 @@
 #include <types/ui/ui.h>
 #include <types/ui/window.h>
+#include <uchar.h>
 
 extern errno_t ui_menu_bar_create(ui_t *, ui_window_t *,
     ui_menu_bar_t **);
 extern void ui_menu_bar_destroy(ui_menu_bar_t *);
+extern void ui_menu_bar_set_cb(ui_menu_bar_t *, ui_menu_bar_cb_t *, void *);
 extern ui_control_t *ui_menu_bar_ctl(ui_menu_bar_t *);
 extern void ui_menu_bar_set_rect(ui_menu_bar_t *, gfx_rect_t *);
 extern errno_t ui_menu_bar_paint(ui_menu_bar_t *);
+extern ui_evclaim_t ui_menu_bar_kbd_event(ui_menu_bar_t *, kbd_event_t *);
 extern ui_evclaim_t ui_menu_bar_pos_event(ui_menu_bar_t *, pos_event_t *);
+extern void ui_menu_bar_press_accel(ui_menu_bar_t *, char32_t, sysarg_t);
 extern void ui_menu_bar_unfocus(ui_menu_bar_t *);
+extern void ui_menu_bar_activate(ui_menu_bar_t *);
+extern void ui_menu_bar_deactivate(ui_menu_bar_t *);
+extern void ui_menu_bar_select_first(ui_menu_bar_t *, bool, sysarg_t);
+extern void ui_menu_bar_select_last(ui_menu_bar_t *, bool, sysarg_t);
 
 #endif
